﻿@using DocumentFormat.OpenXml.Wordprocessing
@{
    ViewBag.Title = "Matrix Param Mapping";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<link href="~/Content/plugins/datatables/css/dataTables.bootstrap.css" rel="stylesheet" />
<script src="~/Content/plugins/datatables/js/jquery.dataTables.min.js"></script>
<script src="~/Content/plugins/datatables/js/jquery.dataTables.columnFilter.js"></script>
<script src="~/Content/plugins/datatables/js/dataTables.bootstrap.js"></script>


<script type="text/javascript">

    var oTable;

    function loadParamGroup() {
        return $.ajax({
            url: '@Url.Action("GetParamGroup", "AppParamMapping")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $.each(results, function (i, result) {
                    $('#ddlgroupparam1').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                    $('#ddlgroupparam2').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                    $('#ddlgroupparam3').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlgroupparam1').append('<option value="">No data found</option>');
                $('#ddlgroupparam2').append('<option value="">No data found</option>');
                $('#ddlgroupparam3').append('<option value="">No data found</option>');

            }
        });
    }

    function loadParam1() {
        return $.ajax({
            url: '@Url.Action("GetParam", "AppParamMapping")?groupid=' + $('#ddlgroupparam1').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                var $el = $("#ddlparam1");
                $el.empty(); // remove old options
                $.each(results, function (i, result) {
                    $('#ddlparam1').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlparam1').append('<option value="">No data found</option>');

            }
        });
    }
    function loadParam2() {
        return $.ajax({
            url: '@Url.Action("GetParam", "AppParamMapping")?groupid=' + $('#ddlgroupparam2').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                var $el = $("#ddlparam2");
                $el.empty(); // remove old options
                $.each(results, function (i, result) {
                    $('#ddlparam2').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlparam2').append('<option value="">No data found</option>');

            }
        });
    }
    function loadParam3() {
        return $.ajax({
            url: '@Url.Action("GetParam", "AppParamMapping")?groupid=' + $('#ddlgroupparam3').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                var $el = $("#ddlresult");
                $el.empty(); // remove old options
                $.each(results, function (i, result) {
                    $('#ddlresult').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlresult').append('<option value="">No data found</option>');

            }
        });
    }

    
    $(document).ready(function () {

        loadParamGroup().then(loadParam1).then(loadParam2).then(loadParam3);

        $("#btnSave").click(function () {
            //validation
            if ($('#txtdescription').val().length == 0 ) {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please fill mandatory field (<label class='required'></label>)", function () {
                    setTimeout(function () { }, 500);
                });
            } else {

                //confirmation
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Save Confirmation",
                    message: 'Are you sure you want to save this data. <br>If not, click Cancel',
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue save',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            var AppParamMappingList = [
                                 {
                                     id: '@ViewBag.RowId',
                                     groupname: $('#txtdescription').val(),
                                     param1group: $('#ddlgroupparam1').val(),
                                     param1: $('#ddlparam1').val(),
                                     param2group: $('#ddlgroupparam2').val(),
                                     param2: $('#ddlparam2').val(),
                                     param3group: $('#ddlgroupparam3').val(),
                                     result: $('#ddlresult').val()
                                 }
                            ];

                            AppParamMappingList.push();

                            var formData = new FormData();
                            formData.append("AppParamMappingList", JSON.stringify(AppParamMappingList));


                            //Save Process
                            $.ajax({
                                type: "POST",
                                url: '@Url.Action("SaveAppParamMapping", "AppParamMapping")',
                                data: formData,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                //beforeSend: function () {
                                //    //$("#loader").show();
                                //},
                                success: function (data) {
                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            window.location.href = '@Url.Action("AppParamMapping", "AppParamMapping")';
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });
                                }
                            });

                        }
                    }
                });
            }


        });

        $(document).on("change", '#ddlgroupparam1', function (e) {
            loadParam1();
        });
        $(document).on("change", '#ddlgroupparam2', function (e) {
            loadParam2();
        });
        $(document).on("change", '#ddlgroupparam3', function (e) {
            loadParam3();
        });
    });


</script>

<style>
    .label-def-margin {
        margin-top: 6px;
    }

    .required:after {
        content: "*";
        color: red;
    }
</style>


<div class="col-sm-12">
    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Add Matrix Param

        </div>
        <div class="panel-body">

            <div class="row">
                <div class="col-sm-1"><label class="label-def-margin required" for="txtdescription">Description</label></div>
                <div class="col-sm-8"><textarea class="form-control" rows="2" id="txtdescription"></textarea></div>
            </div>
            <hr />
            <div class="row">
                <!--Group Param 1-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlgroupparam1">Param 1</label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlgroupparam1"></select>
                </div>
                <!--Group Param 2-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlgroupparam2">Param 2</label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlgroupparam2"></select>
                </div>
            </div>
            <div class="row">
                <!--Param 1-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlparam1"></label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlparam1"></select>
                </div>
                <!--Param 2-->
                <div class="col-sm-1"><label class="label-def-margin" for="ddlparam2"></label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlparam2"></select>
                </div>
            </div>
            <hr/>
            <!--Result-->
            <!--Group Param 3-->
            <div class="row">
                <div class="col-sm-1"><label class="label-def-margin" for="ddlgroupparam3">Result</label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlgroupparam3"></select>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-1"><label class="label-def-margin" for="ddlresult"></label></div>
                <div class="col-sm-4">
                    <select class="form-control" id="ddlresult"></select>
                </div>
            </div>
            

        </div>
        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-12">
                    <button type="button" class="btn btn-primary" id="btnSave">
                        <span class="glyphicon glyphicon-floppy-disk"></span> Save
                    </button>
                    &nbsp;
                    <button type="button" class="btn btn-primary" onclick="@("window.location.href='" + @Url.Action("AppParamMapping", "AppParamMapping") + "'");">
                        <span class="glyphicon glyphicon-circle-arrow-left"></span> Back
                    </button>
                </div>
            </div>
        </div>



    </div>
</div>
